Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Read_queue/include/Read_queue.h
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Read_queue/include/Read_queue.h	(revision 66)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Read_queue/include/Read_queue.h	(revision 75)
@@ -21,5 +21,5 @@
 #include "Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Read_queue/include/Parameters.h"
 #ifdef STATISTICS
-#include "Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Read_queue/include/Statistics.h"
+#include "Behavioural/include/Stat.h"
 #endif
 #include "Behavioural/include/Component.h"
@@ -27,6 +27,4 @@
 #include "Behavioural/include/Vhdl.h"
 #endif
-
-using namespace std;
 
 namespace morpheo {
@@ -60,25 +58,25 @@
   public    : Tspecial_address_t _num_reg_re   ;
 
-    friend ostream& operator<< (ostream& output_stream,
+    friend std::ostream& operator<< (std::ostream& output_stream,
 				morpheo::behavioural::core::multi_execute_loop::execute_loop::multi_read_unit::read_unit::read_queue::Tread_queue_entry_t & x)
     {
-      output_stream << " * _context_id    : " << toString(x._context_id   ) << endl
-		    << " * _front_end_id  : " << toString(x._front_end_id ) << endl
-		    << " * _ooo_engine_id : " << toString(x._ooo_engine_id) << endl
-		    << " * _rob_id        : " << toString(x._rob_id       ) << endl
-		    << " * _operation     : " << toString(x._operation    ) << endl
-		    << " * _type          : " << toString(x._type         ) << endl
-		    << " * _has_immediat  : " << toString(x._has_immediat ) << endl
-		    << " * _immediat      : " << toString(x._immediat     ) << endl
-		    << " * _read_ra       : " << toString(x._read_ra      ) << endl
-		    << " * _num_reg_ra    : " << toString(x._num_reg_ra   ) << endl
-		    << " * _read_rb       : " << toString(x._read_rb      ) << endl
-		    << " * _num_reg_rb    : " << toString(x._num_reg_rb   ) << endl
-		    << " * _read_rc       : " << toString(x._read_rc      ) << endl
-		    << " * _num_reg_rc    : " << toString(x._num_reg_rc   ) << endl
-		    << " * _write_rd      : " << toString(x._write_rd     ) << endl
-		    << " * _num_reg_rd    : " << toString(x._num_reg_rd   ) << endl
-		    << " * _write_re      : " << toString(x._write_re     ) << endl
-		    << " * _num_reg_re    : " << toString(x._num_reg_re   ) << endl;
+      output_stream << " * _context_id    : " << toString(x._context_id   ) << std::endl
+		    << " * _front_end_id  : " << toString(x._front_end_id ) << std::endl
+		    << " * _ooo_engine_id : " << toString(x._ooo_engine_id) << std::endl
+		    << " * _rob_id        : " << toString(x._rob_id       ) << std::endl
+		    << " * _operation     : " << toString(x._operation    ) << std::endl
+		    << " * _type          : " << toString(x._type         ) << std::endl
+		    << " * _has_immediat  : " << toString(x._has_immediat ) << std::endl
+		    << " * _immediat      : " << toString(x._immediat     ) << std::endl
+		    << " * _read_ra       : " << toString(x._read_ra      ) << std::endl
+		    << " * _num_reg_ra    : " << toString(x._num_reg_ra   ) << std::endl
+		    << " * _read_rb       : " << toString(x._read_rb      ) << std::endl
+		    << " * _num_reg_rb    : " << toString(x._num_reg_rb   ) << std::endl
+		    << " * _read_rc       : " << toString(x._read_rc      ) << std::endl
+		    << " * _num_reg_rc    : " << toString(x._num_reg_rc   ) << std::endl
+		    << " * _write_rd      : " << toString(x._write_rd     ) << std::endl
+		    << " * _num_reg_rd    : " << toString(x._num_reg_rd   ) << std::endl
+		    << " * _write_re      : " << toString(x._write_re     ) << std::endl
+		    << " * _num_reg_re    : " << toString(x._num_reg_re   ) << std::endl;
 
       return output_stream;
@@ -156,34 +154,34 @@
     }
 
-    friend ostream& operator<< (ostream& output_stream,
+    friend std::ostream& operator<< (std::ostream& output_stream,
 				morpheo::behavioural::core::multi_execute_loop::execute_loop::multi_read_unit::read_unit::read_queue::Tread_queue_head_entry_t & x)
     {
-      output_stream << " * _context_id    : " << x._context_id   << endl
-		    << " * _front_end_id  : " << x._front_end_id << endl
-		    << " * _ooo_engine_id : " << x._ooo_engine_id<< endl
-		    << " * _rob_id        : " << x._rob_id       << endl
-		    << " * _operation     : " << x._operation    << endl
-		    << " * _type          : " << x._type         << endl
-		    << " * _has_immediat  : " << x._has_immediat << endl
-		    << " * _immediat      : " << x._immediat     << endl
-		    << " * _read_ra       : " << x._read_ra      << endl
-		    << " * _read_ra_val   : " << x._read_ra_val  << endl 
-		    << " * _num_reg_ra    : " << x._num_reg_ra   << endl
-		    << " * _data_ra_val   : " << x._data_ra_val  << endl
-		    << " * _data_ra       : " << x._data_ra      << endl
-		    << " * _read_rb       : " << x._read_rb      << endl
-		    << " * _read_rb_val   : " << x._read_rb_val  << endl
-		    << " * _num_reg_rb    : " << x._num_reg_rb   << endl
-		    << " * _data_rb_val   : " << x._data_rb_val  << endl
-		    << " * _data_rb       : " << x._data_rb      << endl
-		    << " * _read_rc       : " << x._read_rc      << endl
-		    << " * _read_rc_val   : " << x._read_rc_val  << endl
-		    << " * _num_reg_rc    : " << x._num_reg_rc   << endl
-		    << " * _data_rc_val   : " << x._data_rc_val  << endl
-		    << " * _data_rc       : " << x._data_rc      << endl
-		    << " * _write_rd      : " << x._write_rd     << endl
-		    << " * _num_reg_rd    : " << x._num_reg_rd   << endl
-		    << " * _write_re      : " << x._write_re     << endl
-		    << " * _num_reg_re    : " << x._num_reg_re   << endl;
+      output_stream << " * _context_id    : " << x._context_id   << std::endl
+		    << " * _front_end_id  : " << x._front_end_id << std::endl
+		    << " * _ooo_engine_id : " << x._ooo_engine_id<< std::endl
+		    << " * _rob_id        : " << x._rob_id       << std::endl
+		    << " * _operation     : " << x._operation    << std::endl
+		    << " * _type          : " << x._type         << std::endl
+		    << " * _has_immediat  : " << x._has_immediat << std::endl
+		    << " * _immediat      : " << x._immediat     << std::endl
+		    << " * _read_ra       : " << x._read_ra      << std::endl
+		    << " * _read_ra_val   : " << x._read_ra_val  << std::endl 
+		    << " * _num_reg_ra    : " << x._num_reg_ra   << std::endl
+		    << " * _data_ra_val   : " << x._data_ra_val  << std::endl
+		    << " * _data_ra       : " << x._data_ra      << std::endl
+		    << " * _read_rb       : " << x._read_rb      << std::endl
+		    << " * _read_rb_val   : " << x._read_rb_val  << std::endl
+		    << " * _num_reg_rb    : " << x._num_reg_rb   << std::endl
+		    << " * _data_rb_val   : " << x._data_rb_val  << std::endl
+		    << " * _data_rb       : " << x._data_rb      << std::endl
+		    << " * _read_rc       : " << x._read_rc      << std::endl
+		    << " * _read_rc_val   : " << x._read_rc_val  << std::endl
+		    << " * _num_reg_rc    : " << x._num_reg_rc   << std::endl
+		    << " * _data_rc_val   : " << x._data_rc_val  << std::endl
+		    << " * _data_rc       : " << x._data_rc      << std::endl
+		    << " * _write_rd      : " << x._write_rd     << std::endl
+		    << " * _num_reg_rd    : " << x._num_reg_rd   << std::endl
+		    << " * _write_re      : " << x._write_re     << std::endl
+		    << " * _num_reg_re    : " << x._num_reg_re   << std::endl;
 
       return output_stream;
@@ -198,9 +196,9 @@
     // -----[ fields ]----------------------------------------------------
     // Parameters
-  protected : const string                     _name;
+  protected : const std::string                _name;
   protected : const Parameters               * _param;
 
 #ifdef STATISTICS
-  private   : Statistics                     * _stat;
+  public    : Stat                           * _stat;
 #endif
 
@@ -302,5 +300,5 @@
     // ~~~~~[ Register ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~    
   protected : Tread_queue_head_entry_t       * _queue_head;
-  protected : queue<Tread_queue_entry_t *>   * _queue;
+  protected : std::queue<Tread_queue_entry_t *>   * _queue;
 
     // ~~~~~[ Internal ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
@@ -328,5 +326,5 @@
 					      sc_module_name                              name,
 #else					       
-					      string                                      name,
+					      std::string                                 name,
 #endif					       
 #ifdef STATISTICS
@@ -349,5 +347,5 @@
 #endif					       
 #ifdef STATISTICS
-  public  : string   statistics                (uint32_t depth);
+  public  : void     statistics_declaration    (morpheo::behavioural::Parameters_Statistics * param_statistics);
 #endif
 					       
@@ -357,7 +355,7 @@
   private : void     vhdl_body                 (Vhdl * & vhdl);
 #endif					       
-					       
-#ifdef VHDL_TESTBENCH			       
-  private : void     vhdl_testbench_transition (void);
+			
+#if defined(STATISTICS) or defined(VHDL_TESTBENCH)
+  private : void     end_cycle                 (void);
 #endif
   };
